/* @(#) sweep.cc %I% %D% */
/* %P% */
 
static char SCID[] = "@(#) MC++: sweep.cc (c) V. Carey, ver. %I% , %D%";

#include "MC++.h"

matrix sweep( matrix& mat ) /* FUNCTION */

/* algorithm follows Goodnight, Amer Stat Aug 1979 p.149 */

{

int k , j , i ;
double d , b, *in, *out, *curtmp;
matrix temp;

temp = newmat(mat.rows(),mat.cols());
int tcol = temp.cols();
int trow = temp.rows();

in = mat.mathead();
out = temp.mathead();

for ( i = 0 ; i < trow*tcol ; /* copy to out */
		*(out++) = *(in++), i++ )
		;

out = temp.mathead();

for ( k = 0 ; k < trow ; k++ )   /* do 3 */

	{

	d = temp.el(k,k);

	for ( j = 0 ; j < trow ; j++ )   /*do 1 */

		{

		curtmp = out + j + k*(tcol);  /* address to load */
		*curtmp = temp.el(k,j) / d ;

		}   /* 1 */

	for ( i = 0 ; i < trow ; i++ )  /* do 2 */

		{

		if ( i != k ) 

			{

			b = temp.el(i,k);

			for ( j = 0 ; j < trow ; j++ )

				{

				curtmp = out + j + i*(tcol);
				*curtmp = temp.el(i,j) - b*temp.el(k,j); 

				}

			curtmp = out + k + i*(tcol);
			*curtmp = -b / d;

			}   /* end else: 2 */  

		}					/* 2 */	

		curtmp = out + k + k*(tcol);
		*curtmp = (double) 1.0 / d ;

	}  /* 3 */

return temp;

}
